
; ========================================================
;			
;    -- StringFuncs.asm --
;			Jay Sullivan*
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include TextReaderSquare.inc
		
;------------------------------------------------
;                .CODE
;------------------------------------------------


.CODE

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

;; *Full credit for algorithm is given to Hutch
StringLength proc item:DWORD

    push edi
    push esi

    mov eax, [esp+12]
    mov ecx, eax                ; copy EAX to ECX
    add ecx, 3                  ; align up by 4
    and ecx, -4       
    sub ecx, eax                ; calculate any misalignment in ecx
    mov esi, ecx                ; store ECX in ESI
    jz proceed

    sub eax, 1
  @@:
    add eax, 1
    cmp BYTE PTR [eax], 0       ; scan for terminator for
    je quit                     ; up to the 1st 3 bytes
    sub ecx, 1
    jns @B
    jmp proceed

  quit:
    sub eax, [esp+12]           ; calculate length if terminator
    jmp outa_here               ; is found in 1st 3 bytes

  ; ----------------

  proceed:                      ; proceed with the rest
    lea edx, [eax+3]            ; pointer+3 used in the end
  align 4
  @@:     
    mov edi, [eax]              ; read first 4 bytes
    add eax, 4                  ; increment pointer
    lea ecx, [edi-01010101h]    ; subtract 1 from each byte
    not edi                     ; invert all bytes
    and ecx, edi                ; and these two
    and ecx, 80808080h    
    jz @B                       ; no zero bytes, continue loop
    test ecx, 00008080h         ; test first two bytes
    jnz @F
    shr ecx, 16                 ; not in the first 2 bytes
    add eax, 2
  @@:
    shl cl, 1                   ; use carry flag to avoid branch
    sbb eax, edx                ; compute length
    add eax, esi

  outa_here:
    pop esi
    pop edi

    ret 4

StringLength endp

align 4
;; *Full credit for algorithm is given to MichaelW
StringCopy proc lpdest:DWORD,lpsrc:DWORD
    push  ebx
    mov   edx,[esp+8]          ; lpdest
    mov   eax,[esp+12]           ; lpsrc
    align 4
  @@:
    REPEAT 8                    ; unroll x 8
      mov   ebx,[eax]           ; get next 4 bytes
      add   eax,4
      lea   ecx,[ebx-01010101h] ; subtract 1 from each byte
      not   ebx                 ; invert all bytes      
      and   ecx,ebx             ; and each byte with inversion
      not   ebx                 ; restore bytes
      and   ecx,80808080h       ; bytes=80h for null,otherwise 0
      jnz   @F                  ; jump if zero byte present
      mov   [edx],ebx           ; copy 4 bytes
      add   edx,4
    ENDM
    jmp   @B
  @@:
    mov   [edx],bl              ; move first byte
    add   edx,1
    test  bl,bl
    jz    @F                    ; jump if was null
    mov   [edx],bh              ; move next byte
    add   edx,1
    test  bh,bh
    jz    @F                    ; jump if was null
    shr   ebx,16
    mov   [edx],bl              ; move next byte
    add   edx,1
    test  bl,bl
    jz    @F                    ; jump if was null
    mov   [edx],bh              ; move last byte
  @@:
    mov   eax,edx               ; return length w/o null
    sub   eax,[esp+8]          ; lpdest

    pop   ebx
    ret   8
StringCopy endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

; 
end