	
; ========================================================
;			
;    -- TextReaderSquare.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include TextReaderSquare.inc
		include TextReaderSquareData.inc
	
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke GetProcessHeap
		mov hHeap, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG


	;------------------------------------------------
	;	Windows
	;------------------------------------------------
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, TRSICO
			mov wc.hIcon,eax
			invoke LoadImage,hInst, TRSICO , IMAGE_ICON, 16, 16, 0
			mov wc.hIconSm,eax
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
			
		;------------------------------------------------
		;	Menus Create
		;------------------------------------------------
				invoke LoadMenu, hInst, Offset MainMenuName
				mov hMenu,eax
			    invoke GetSubMenu, eax, IDM_EDIT
			    mov hPopUpEdit,eax
			    
				invoke LoadMenu, hInst, Offset ContextMenuName
				mov hContextMenu,eax
				invoke GetSubMenu, eax, IDM_CONTEXT
				mov hPopUpContext, eax
				
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\
				CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,\
				NULL,hMenu,hInst,NULL
			mov hMainWindow,eax
			mov hActiveWindow, eax
			
			
		;------------------------------------------------
		;	CHOOSECOLOR Palette Entries
		;------------------------------------------------
			    invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, 16*4
			    mov cc.CHOOSECOLOR.lpCustColors, eax
		;------------------------------------------------
		;	Zero out first few characters of Open/SaveAs boxes
		;------------------------------------------------
			    mov dword ptr szFilePath, 0
			    mov dword ptr szFileName, 0
			    mov dword ptr bgFilePath, 0
			    mov dword ptr bgFileName, 0
		
	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hMainWindow, SW_SHOWNORMAL
			invoke UpdateWindow, hMainWindow
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL wc:WNDCLASSEX, myRect:RECT
LOCAL hTempFont:DWORD, hTempText:DWoRD
LOCAL hNewWindow:HWND, pNewSquare:DWORD, NumberOfSquares:DWORD
LOCAL hCreateFile:DWORD, hCreateFileMapping:DWORD, hMapViewOfFile:DWORD
LOCAL hdc:HDC, hdcMem:HDC, ps:PAINTSTRUCT, bm:BITMAP, hbmOld:HBITMAP
	mov eax, uMsg
	;-----------------------------
	 .if eax==WM_DESTROY
	;-----------------------------
		
		invoke PostQuitMessage, NULL
	;-----------------------------
	.elseif eax==WM_CREATE
	;-----------------------------
	
		;------------------------------------------------
		;	Get Device Caps
		;------------------------------------------------

			invoke GetDC,hWnd
			push eax
				invoke GetDeviceCaps,eax, LOGPIXELSY
				mov DeviceCaps, eax
			pop eax
			invoke ReleaseDC, hWnd, eax
			
		    
		;------------------------------------------------
		;	InfoText Window Register
		;------------------------------------------------
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW 
			mov wc.lpfnWndProc, Offset InfoTextProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,0
			mov eax,hInstance
			mov wc.hInstance,eax
			mov wc.hbrBackground, 0
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset InfoTextClassName
			mov wc.hIcon,0
			mov wc.hIconSm,0
			invoke LoadCursor, NULL,IDC_HAND
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc

	;-----------------------------
	.elseif eax==WM_CONTEXTMENU
	;-----------------------------
	
	
	
				mov ecx, lParam
				mov eax, lParam
				shr ecx, 16
				and eax, 0FFFFh
				invoke TrackPopupMenu, hPopUpContext, TPM_LEFTALIGN, eax, ecx, 0, hWnd, 0
				
	;-----------------------------
	.elseif eax==WM_RBUTTONDOWN || eax==WM_LBUTTONDOWN || eax == WM_NOSELECTION
	;-----------------------------
		
		mov ecx, hWnd
		.if ecx != hActiveWindow
			mov hActiveWindow, ecx
			invoke InvalidateRect, hWnd, 0, TRUE
			invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN
			invoke EnableMenuItem, hMenu, IDM_EDIT_TEXT, MF_GRAYED or MF_DISABLED
			invoke EnableMenuItem, hMenu, IDM_EDIT_FONT, MF_GRAYED or MF_DISABLED
			invoke EnableMenuItem, hMenu, IDM_EDIT_COPY, MF_GRAYED or MF_DISABLED
			invoke EnableMenuItem, hMenu, IDM_EDIT_DELETE, MF_GRAYED or MF_DISABLED
		.endif
		
		
				
	;-----------------------------
	.elseif eax == WM_PAINT
	;-----------------------------
			.if toggleBackground!=0 && g_hbmBackground!=0
			
				invoke BeginPaint, hWnd, ADDR ps
				mov hdc, eax
				
				invoke CreateCompatibleDC, hdc
				mov hdcMem, eax
				
				invoke SelectObject,hdcMem, g_hbmBackground
				mov hbmOld, eax 
				
				invoke GetObject,g_hbmBackground, Sizeof BITMAP, ADDR bm
				
				invoke BitBlt,hdc, 0, 0, bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY
				
				invoke SelectObject,hdcMem, hbmOld
				invoke DeleteDC,hdcMem
				
				invoke EndPaint, hWnd, ADDR ps
			.else
			
				invoke DefWindowProc, hWnd, uMsg, wParam, lParam
				ret
				
			.endif
	;-----------------------------
	.elseif eax == WM_ERASEBKGND 
	;-----------------------------
			; Erase if we aren't painting
			.if toggleBackground==0 || g_hbmBackground==0
				invoke DefWindowProc, hWnd, uMsg, wParam, lParam
				ret
			.else
				mov eax, 1
				ret
			.endif
	;-----------------------------
	 .elseif eax==WM_COMMAND
	;-----------------------------
		
		mov	eax,wParam
		and eax, 0FFFFh
		;-----------------------------
		.if	eax==IDM_EDIT_FONT || eax==IDM_EDIT_TEXT || eax==IDM_EDIT_COPY || eax==IDM_EDIT_DELETE
		;-----------------------------
			invoke SendMessage,  hActiveWindow, uMsg, wParam, lParam
			ret
		;-----------------------------
		.elseif eax == IDM_FILE_OPEN
		;-----------------------------
		push esi
		push edi
		push ebx
		
			;-----------------------------
			; Request info from user
			;-----------------------------
			
				invoke GetOpenFileName, Offset ofn
				.if eax==0
					jmp OpenCanceled
				.endif
				
			;-----------------------------
			; New Project
			;-----------------------------
			
				invoke EnumChildWindows, hWnd, Offset EnumAllChildren, 2
				
		;-----------------------------------------------
		;  START MEMORY MAPPING PROCESS
		;-----------------------------------------------
			
			;-----------------------------
			;  CreateFile
			;-----------------------------
			
				invoke CreateFile, Offset szFilePath,GENERIC_READ,0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
				mov hCreateFile, eax
			;-----------------------------
			;  CreateFileMapping 
			;-----------------------------
				invoke CreateFileMapping, hCreateFile, NULL, PAGE_READONLY,  0, 0, NULL
				mov hCreateFileMapping, eax

			;-----------------------------
			;  MapViewOfFile 
			;-----------------------------
				invoke MapViewOfFile, hCreateFileMapping,  FILE_MAP_READ, 0, 0, 0
				mov hMapViewOfFile, eax
				mov esi, eax
				
					;-----------------------------
					;  Read Header From File
					;-----------------------------
							; /--------------------------\
							; |    File Header Format    |
							; |--------------------------|
							; |                          |
							; |  LengthOfHeader:DWORD    |
							; |  NumberOfWindows:DWORD   |
							; |  CoordX:DWORD            |
							; |  CoordY:DWORD            |
							; |  CoordW:DWORD            |
							; |  CoordH:DWORD            |
							; |  ??bgFileName:BYTE[?]      |
							; |                          |
							; \--------------------------/
							
						;-----------------------------
						;  Set Number Of Squares To Create
						;-----------------------------
							mov eax,  dword ptr [esi+4]
							mov NumberOfSquares, eax
						;-----------------------------
						; Set Main Window Rectangle
						;-----------------------------

							invoke MoveWindow,hWnd,dword ptr [esi+8], dword ptr [esi+12], dword ptr [esi+16], dword ptr [esi+20], TRUE
							
						add esi, dword ptr [esi]
					;-----------------------------
					;  Read File Entries From File
					;-----------------------------
							; /--------------------------\
							; |    File Entry Format     |
							; |--------------------------|
							; |                          |
							; |  LengthOfEntry:DWORD     |
							; |  LengthOfString:DWORD    |
							; |  fgColor:DWORD           |
							; |  bgColor:DWORD           |
							; |  CoordX:DWORD           |
							; |  CoordY:DWORD           |
							; |  CoordW:DWORD           |
							; |  CoordH:DWORD           |
							; |  LOGFONT:BYTE[60]        |
							; |  String:BYTE(?)          |
							; |                          |
							; \--------------------------/
						.while NumberOfSquares > 0
							invoke SquareAlloc
							mov pNewSquare, eax
							mov edi, eax
							
							mov eax, [esi+8]
							mov ecx, [esi+12]
							mov [edi].Square.fgColor, eax ; fgColor
							mov [edi].Square.bgColor, ecx ; bgColor
							
							mov eax, dword ptr [esi+4]
							invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, eax
							mov [edi].Square.szText, eax 
							
							mov eax, esi
							add eax, 60+32
							invoke StringCopy, [edi].Square.szText, eax; String
						
									
						;-----------------------------
						;  LOGFONT:BYTE[60]
						;-----------------------------
							push esi
							push edi
								mov edi, [edi].Square.hLogFont
								add esi, 32
								for N,<0, 16, 32>
								mov eax, dword ptr [esi + N + 0 ]
								mov ebx, dword ptr [esi + N + 4 ]
								mov ecx, dword ptr [esi + N + 8 ]
								mov edx, dword ptr [esi + N + 12]
								mov dword ptr [edi + N + 0 ], eax
								mov dword ptr [edi + N + 4 ], ebx
								mov dword ptr [edi + N + 8 ], ecx
								mov dword ptr [edi + N + 12], edx
								endm
								mov eax, dword ptr [esi + 48 + 0 ]
								mov ecx, dword ptr [esi + 48 + 4 ]
								mov edx, dword ptr [esi + 48 + 8 ]
								mov dword ptr [edi + 48 + 0 ], eax
								mov dword ptr [edi + 48 + 4 ], ecx
								mov dword ptr [edi + 48 + 8 ], edx
							pop edi
							pop esi
							
							
							invoke CreateWindowEx, 0  , Offset InfoTextClassName, 0, WS_VISIBLE or WS_CHILDWINDOW or WS_CLIPSIBLINGS, dword ptr [esi+16], dword ptr [esi+20],dword ptr [esi+24],dword ptr [esi+28],hWnd,0,hInstance,pNewSquare

							add esi,  dword ptr [esi]
							sub NumberOfSquares, 1
						.endw
						
						invoke InvalidateRect, hWnd, 0, TRUE
						invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN
				
						
			;-----------------------------
			;  UnmapViewOfFile 
			;-----------------------------
			
				invoke UnmapViewOfFile, hMapViewOfFile
				invoke CloseHandle, hCreateFileMapping
				invoke CloseHandle, hCreateFile
				
				
				
				
				
				OpenCanceled:
				pop ebx
				pop edi
				pop esi
		;-----------------------------
		.elseif eax == IDM_FILE_SAVEAS
		;-----------------------------
		
			;-----------------------------
			; Request info from user
			;-----------------------------
			
				invoke GetSaveFileName, Offset ofn
				.if eax==0
					ret
				.endif
				
				
			;-----------------------------
			;  Get Potential Save File Size
			;-----------------------------
				
				mov CountTotalFileSize, 4*6  ; Length of Header
				mov CountTotalNumberOfWindows, 0
				invoke EnumChildWindows, hWnd, Offset EnumAllChildren, 0
		
		;-----------------------------------------------
		;  START MEMORY MAPPING PROCESS
		;-----------------------------------------------
			
			;-----------------------------
			;  CreateFile
			;-----------------------------
			
				invoke CreateFile, Offset szFilePath,GENERIC_READ or GENERIC_WRITE,0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
				mov hCreateFile, eax

			;-----------------------------
			;  CreateFileMapping 
			;-----------------------------
				invoke CreateFileMapping, hCreateFile, NULL, PAGE_READWRITE,  0, CountTotalFileSize, NULL
				mov hCreateFileMapping, eax

			;-----------------------------
			;  MapViewOfFile 
			;-----------------------------
				invoke MapViewOfFile, hCreateFileMapping,  FILE_MAP_ALL_ACCESS, 0, 0, 0
				mov hMapViewOfFile, eax
				
				mov OffsetViewOfFile, eax

					;-----------------------------
					;  Write Header To File
					;-----------------------------
							; /--------------------------\
							; |    File Header Format    |
							; |--------------------------|
							; |                          |
							; |  LengthOfHeader:DWORD    |
							; |  NumberOfWindows:DWORD   |
							; |  CoordX:DWORD            |
							; |  CoordY:DWORD            |
							; |  CoordW:DWORD            |
							; |  CoordH:DWORD            |
							; |  ??bgFileName:BYTE[?]      |
							; |                          |
							; \--------------------------/
								mov ecx, CountTotalNumberOfWindows
								mov dword ptr [eax],   4*6 ; LengthOfHeader:DWORD
								mov dword ptr [eax+4], ecx ; NumberOfWindows:DWORD
								
								invoke GetWindowRect, hWnd, ADDR myRect
								mov edx, OffsetViewOfFile
								mov eax, myRect.RECT.left
								mov ecx, myRect.RECT.top
								mov dword ptr [edx+8 ], eax  ; CoordX:DWORD
								mov dword ptr [edx+12], ecx  ; CoordY:DWORD
								mov eax, myRect.RECT.right
								mov ecx, myRect.RECT.bottom
								sub eax, myRect.RECT.left
								sub ecx, myRect.RECT.top
								mov dword ptr [edx+16], eax  ; CoordW:DWORD
								mov dword ptr [edx+20], ecx  ; CoordH:DWORD
								
								
								
								add OffsetViewOfFile, 4*6
					;-----------------------------
					;  Write Windows To File
					;-----------------------------
					
							invoke EnumChildWindows, hWnd, Offset EnumAllChildren, 1
					
						
						
			;-----------------------------
			;  UnmapViewOfFile 
			;-----------------------------
			
				invoke UnmapViewOfFile, hMapViewOfFile
				invoke CloseHandle, hCreateFileMapping
				invoke CloseHandle, hCreateFile
				
		;-----------------------------
		.elseif eax == IDM_VIEW_BORDERS
		;-----------------------------
			xor toggleBorders,1
			.if toggleBorders==0
				mov eax, MF_UNCHECKED
			.else
				mov eax, MF_CHECKED
			.endif
			invoke CheckMenuItem, hMenu, IDM_VIEW_BORDERS, eax
			invoke InvalidateRect, hWnd, 0, TRUE
			invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN
		;-----------------------------
		.elseif eax == IDM_VIEW_BACKGROUND
		;-----------------------------
			xor toggleBackground,1
			.if toggleBackground==0
				mov eax, MF_UNCHECKED
			.else
				mov eax, MF_CHECKED
			.endif
			invoke CheckMenuItem, hMenu, IDM_VIEW_BACKGROUND, eax
			invoke InvalidateRect, hWnd, 0, TRUE
			invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN

		
		;-----------------------------
		.elseif	eax==IDM_FILE_CLOSEBG
		;-----------------------------
		
				.if g_hbmBackground == 0
					int 3
				.endif
				
				invoke DeleteObject, g_hbmBackground
				mov g_hbmBackground,0
				
				invoke EnableMenuItem, hMenu, IDM_FILE_CLOSEBG, MF_GRAYED or MF_DISABLED
				invoke InvalidateRect, hWnd, 0, TRUE
				invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN

				
		;-----------------------------
		.elseif	eax==IDM_FILE_OPENBG
		;-----------------------------
		
			;-----------------------------
			; Request info from user
			;-----------------------------
			
				invoke GetOpenFileName, Offset ofbg
				.if eax==0
					jmp BGOpenCanceled
				.endif
				
			;-----------------------------
			; Delete old bitmap
			;-----------------------------
			
				.if g_hbmBackground != 0
					invoke DeleteObject, g_hbmBackground
				.endif
				
			;-----------------------------
			; Load bitmap
			;-----------------------------
			
				invoke LoadImage,0, Offset bgFilePath,IMAGE_BITMAP, 0, 0,LR_LOADFROMFILE 
				mov g_hbmBackground, eax
        		.if eax==0
            		invoke MessageBox,hWnd, $String("Could not load background!"), $String("Error"), MB_OK or MB_ICONEXCLAMATION
            		jmp BGOpenCanceled
            	.endif
            	
            	invoke GetClientRect, hWnd, ADDR myRect
            	invoke GetObject, g_hbmBackground,  Sizeof BITMAP, ADDR bm
            	
            	mov eax, bm.bmWidth
            	mov ecx, bm.bmHeight
            	add eax, myRect.left
            	add ecx, myRect.top
            	add eax, 12  ; adjust for non client border
            	add ecx, 58 ; adjust for non client border
            	invoke MoveWindow, hWnd, myRect.left, myRect.top, eax, ecx, TRUE
            	
				invoke EnableMenuItem, hMenu, IDM_FILE_CLOSEBG, MF_ENABLED
				
				invoke InvalidateRect, hWnd, 0, TRUE
				invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN

				BGOpenCanceled:
		;-----------------------------
		.elseif	eax==IDM_FILE_NEW 
		;-----------------------------
		
			invoke MessageBox, hWnd, Offset DoYouWantToSaveChanges, $String("New Project"), MB_YESNOCANCEL or MB_ICONQUESTION

			.if eax == IDYES
			  invoke SendMessage, hWnd, WM_COMMAND, IDM_FILE_SAVEAS, 0
			.elseif eax == IDNO
				invoke EnumChildWindows, hWnd, Offset EnumAllChildren, 2
				
			.endif
			
				invoke InvalidateRect, hWnd, 0, TRUE
				invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN

		;-----------------------------
		.elseif	eax==IDM_CONTEXT_NEW 
		;-----------------------------
		
			;-------------------------------------------
			;  Alloc new Square
			;-------------------------------------------
				invoke SquareAlloc
				mov pNewSquare, eax
				invoke SquareCopy, pNewSquare, Offset myDefaultSquare
				
						
			;-------------------------------------------
			;  Create Window
			;-------------------------------------------
				invoke GetCursorPos, Offset ContextMenuLocation
				invoke ScreenToClient, hWnd, Offset ContextMenuLocation
				invoke CreateWindowEx, 0  , Offset InfoTextClassName, 0, WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS, ContextMenuLocation.POINT.x,ContextMenuLocation.POINT.y,200,50,hWnd,0,hInstance,pNewSquare
				mov hNewWindow, eax
				
			
				invoke InvalidateRect, hWnd, 0, TRUE
				invoke RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN

		;-----------------------------
		.elseif	eax==IDM_CONTEXT_PASTE || eax==IDM_EDIT_PASTE
		;-----------------------------
				
		
				.if pCopyData == 0
					int 3
				.endif
			;-------------------------------------------
			;  Alloc new Square
			;-------------------------------------------
				invoke SquareAlloc
				invoke SquareAlloc
				mov pNewSquare, eax
				invoke SquareCopy, pNewSquare, pCopyData
				
				
			;-------------------------------------------
			;  Create Window
			;-------------------------------------------
				invoke GetCursorPos, Offset ContextMenuLocation
				invoke ScreenToClient, hWnd, Offset ContextMenuLocation
				invoke CreateWindowEx, 0  , Offset InfoTextClassName, 0, WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS, ContextMenuLocation.POINT.x,ContextMenuLocation.POINT.y,200,50,hWnd,0,hInstance, pNewSquare

		;-----------------------------
		.else
		;-----------------------------
		
			invoke DefWindowProc, hWnd, uMsg, wParam, lParam
			ret
			
		;-----------------------------
		 .endif
		;-----------------------------

	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP



InfoTextProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL ps:PAINTSTRUCT, myRect:RECT, hdc:HDC, 
	  pUserData:DWORD, pText:DWORD,
	  hRegionMain:HRGN, hRegionOuter:HRGN, hRegionInner:HRGN, 
	  hRegionText:HRGN, hRegionBorder:HRGN, hRegionBg:HRGN,
	  hOldFont:HFONT,
	  hNewTextBrush:HBRUSH, hNewBorderBrush:HBRUSH, hNewBgBrush:HBRUSH
		;--------------------------------
		;   Store Pointer to Window Data
		;--------------------------------
		
			invoke GetWindowLong,hWnd,GWL_USERDATA
			mov pUserData, eax
		
		;-----------------------------
		;   uMsg
		;-----------------------------
		
			mov eax, uMsg
			
			;-----------------------------
			 .if eax==WM_PAINT		; uMsg
			;-----------------------------
				
				invoke BeginPaint,hWnd, ADDR ps
				mov hdc, eax
				
				;-----------------------------------------------
				;   Setup invisible Colors
				;-----------------------------------------------
			
					invoke SetBkMode,hdc, TRANSPARENT 
					
					
				;-----------------------------------------------
				;   Create Text Clipping Region
				;-----------------------------------------------
						
						;-----------------------------
						;   Set Clipping Path via hFont
						;-----------------------------
							mov eax, pUserData
							invoke CreateFontIndirect, [eax].Square.hLogFont
							invoke SelectObject, hdc, eax
							mov hOldFont, eax
						;-----------------------------
						;   Create Text Path
						;-----------------------------
								invoke GetClientRect,hWnd,ADDR myRect
								invoke BeginPath, hdc
									mov ecx, pUserData
									invoke DrawText, hdc, [ecx].Square.szText,-1, ADDR myRect, DT_SINGLELINE or DT_CENTER or DT_VCENTER 
								invoke EndPath, hdc
								invoke PathToRegion, hdc
								mov hRegionText, eax
						;-----------------------------
						;   Restore Old Font
						;-----------------------------
							invoke SelectObject, hdc, hOldFont
							invoke DeleteObject, eax
						
				;-----------------------------------------------
				;   Create Regions
				;-----------------------------------------------
				
					;-----------------------------------------------
					;   Outer Rectangle (Entire Client Area)
					;-----------------------------------------------
					invoke GetClientRect,hWnd,ADDR myRect
					invoke CreateRectRgn, myRect.left, myRect.top, myRect.right, myRect.bottom
					mov hRegionOuter, eax
					
					;-----------------------------------------------
					;   Inner Rectangle ( Entire Client Area Minus Border)
					;-----------------------------------------------
					add myRect.left, 5
					add myRect.top, 5
					sub myRect.right, 5
					sub myRect.bottom, 5
					invoke CreateRectRgn, myRect.left, myRect.top, myRect.right, myRect.bottom
					mov hRegionInner, eax
					
					;-----------------------------------------------
					;   Background Region (Inner Minus Text)
					;-----------------------------------------------
					invoke CreateRectRgn, myRect.left, myRect.top, myRect.right, myRect.bottom
					mov hRegionBg, eax
					invoke CombineRgn, hRegionBg, hRegionBg, hRegionText, RGN_XOR
					
					
					;-----------------------------------------------
					;   Border Region (Outer Minus Inner)
					;-----------------------------------------------
					
					invoke CreateRectRgn, myRect.left, myRect.top, myRect.right, myRect.bottom
					mov hRegionBorder, eax
					invoke CombineRgn, hRegionBorder, hRegionBorder, hRegionOuter, RGN_XOR
					
					
				;-----------------------------------------------
				;   Combine Regions and Set as Main
				;-----------------------------------------------
				
						invoke CreateRectRgn,0,0,0,0
						mov hRegionMain, eax
						
						mov ecx, pUserData
						.if [ecx].Square.bgColor <= 0FFFFFFh
							mov eax, hRegionInner
						.else
							mov eax, hRegionText
						.endif
						invoke CombineRgn, hRegionMain, hRegionMain, eax, RGN_OR
						
						.if toggleBorders!=0
							mov eax, hRegionBorder
							mov ecx, RGN_OR
						.else
							mov eax, hRegionInner
							mov ecx, RGN_AND
						.endif
						invoke CombineRgn, hRegionMain, hRegionMain, eax, ecx
						invoke SetWindowRgn, hWnd, hRegionMain, TRUE
						
				;-----------------------------------------------
				;   Create Brush and Pen
				;-----------------------------------------------
						
						
						;-----------------------------
						;   Set Text Brush Color
						;-----------------------------
							mov eax, pUserData
							mov ecx, [eax].Square.fgColor
							mov myTextBrush.LOGBRUSH.lbColor, ecx
							invoke CreateBrushIndirect, Offset myTextBrush
							mov hNewTextBrush, eax
							
						;-----------------------------
						;   Set Border Brush Color
						;-----------------------------
							mov ecx, hWnd
							.if ecx == hActiveWindow
								mov eax, Offset myBorderBrushActive
							.else
								mov eax, Offset myBorderBrushUnActive
							.endif
							invoke CreateBrushIndirect, eax
							mov hNewBorderBrush, eax
							
						;-----------------------------
						;   Set Background Brush Color
						;-----------------------------
						
							mov eax, pUserData
							mov ecx, [eax].Square.bgColor
							mov myBgBrush.LOGBRUSH.lbColor, ecx
							invoke CreateBrushIndirect, Offset myBgBrush
							mov hNewBgBrush, eax
							
				;-----------------------------------------------
				;   Draw
				;-----------------------------------------------
							
							invoke FillRgn, hdc, hRegionBg,     hNewBgBrush
							invoke FillRgn, hdc, hRegionText,   hNewTextBrush
							.if toggleBorders!=0
							invoke FillRgn, hdc, hRegionBorder, hNewBorderBrush
							.endif
							
				;-----------------------------------------------
				;   Restore Old Objects and Delete New Ones
				;-----------------------------------------------
						
						;-----------------------------
						;   Delete new brushes
						;-----------------------------
							invoke DeleteObject, hNewBorderBrush
							invoke DeleteObject, hNewTextBrush
							invoke DeleteObject, hNewBgBrush
						;-----------------------------
						;   Delete Regions
						;-----------------------------
							invoke DeleteObject, hRegionMain
							invoke DeleteObject, hRegionText
							invoke DeleteObject, hRegionOuter
							invoke DeleteObject, hRegionInner
							invoke DeleteObject, hRegionBorder
							invoke DeleteObject, hRegionBg
										
				;-----------------------------
				;  Done with WM_PAINT
				;-----------------------------
					
					invoke EndPaint,hWnd,ADDR ps
					
			;-----------------------------
			.elseif eax==WM_ERASEBKGND
			;-----------------------------
				mov eax, 1
				ret
			;-----------------------------
			.elseif eax == WM_NCHITTEST ; uMsg
			;-----------------------------
				invoke GetWindowRect,hWnd, ADDR myRect
				
				
				mov ecx, lParam
				mov eax, lParam
				shr ecx, 16     ; ecx == Y coordinate
				and eax, 0FFFFh ; eax == X coordinate
				add ecx, 5
				add eax, 5
				
				.if eax >  myRect.right
					.if ecx > myRect.bottom
						mov eax, HTBOTTOMRIGHT
					.else
						mov eax, HTRIGHT
					.endif
				.elseif ecx > myRect.bottom
						mov eax, HTBOTTOM
				.else				
					mov eax, HTCAPTION
				.endif
				
				ret
				
			;-----------------------------
			.elseif eax==WM_GETMINMAXINFO
			;-----------------------------
				mov eax, lParam
				mov [eax].MINMAXINFO.ptMinTrackSize.POINT.x, 20
				mov [eax].MINMAXINFO.ptMinTrackSize.POINT.y, 20
			;-----------------------------
			.elseif eax==WM_CREATE
			;-----------------------------
				mov eax, lParam
				invoke SetWindowLong,hWnd,GWL_USERDATA, dword ptr [eax]
			;-----------------------------
			.elseif eax==WM_NCRBUTTONDOWN
			;-----------------------------
	
			
			
				mov ecx, lParam
				mov eax, lParam
				shr ecx, 16
				and eax, 0FFFFh
				invoke TrackPopupMenu, hPopUpEdit, TPM_LEFTALIGN, eax, ecx, 0, hWnd, 0
				

			;-----------------------------
			.elseif eax==WM_MOUSEACTIVATE
			;-----------------------------
			
				invoke SetWindowPos, hWnd, HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE
			
				mov eax, hWnd
				.if eax != hActiveWindow
					;--------------------------------------------------
					; Repaint old window
					;---------------------------------------------------
					invoke InvalidateRect,hWnd,0,TRUE
					;--------------------------------------------------
					; Enable menus
					;---------------------------------------------------
					invoke EnableMenuItem, hMenu, IDM_EDIT_TEXT, MF_ENABLED
					invoke EnableMenuItem, hMenu, IDM_EDIT_FONT, MF_ENABLED
					invoke EnableMenuItem, hMenu, IDM_EDIT_COPY, MF_ENABLED
					invoke EnableMenuItem, hMenu, IDM_EDIT_DELETE, MF_ENABLED
				.endif
			;-----------------------------
			.elseif eax==WM_NCLBUTTONDBLCLK
			;-----------------------------
				invoke SendMessage, hWnd, WM_COMMAND, IDM_EDIT_TEXT, 0
			;-----------------------------
			.elseif eax==WM_COMMAND
			;-----------------------------
			
						mov	eax,wParam
						and eax, 0FFFFh
						;-----------------------------
						.if	eax==IDM_EDIT_FONT
						;-----------------------------
							mov eax, pUserData
							mov ecx, [eax].Square.hLogFont
							mov cf.CHOOSEFONT.lpLogFont, ecx
							mov eax,  hMainWindow
							mov cf.CHOOSEFONT.hwndOwner,eax
							invoke ChooseFont, Offset cf
							invoke InvalidateRect,hWnd,0,TRUE
							
						;-----------------------------
						.elseif	eax==IDM_EDIT_TEXT
						;-----------------------------
							push pUserData
							pop pActiveWindowData
							invoke DialogBoxParam, hInstance, IDD_TEXT, hMainWindow, Offset TextDialogFunc, 0
							
						;-----------------------------
						.elseif	eax==IDM_EDIT_COPY
						;-----------------------------
							invoke SquareAlloc
							mov pCopyData, eax
							invoke SquareCopy, pCopyData, pUserData
				
							invoke EnableMenuItem, hContextMenu, IDM_CONTEXT_PASTE, MF_ENABLED
							invoke EnableMenuItem, hMenu, IDM_EDIT_PASTE, MF_ENABLED
				
						
						;-----------------------------
						.elseif	eax==IDM_EDIT_DELETE
						;-----------------------------
						
							invoke DestroyWindow, hWnd
						;-----------------------------
						.endif
						;-----------------------------

			    
			;-----------------------------
			.elseif eax==WM_DESTROY
			;-----------------------------
				;-----------------------------
				;  Deselect window
				;-----------------------------
						
					mov eax, hWnd
					.if eax==hActiveWindow
						invoke SendMessage, hMainWindow, WM_NOSELECTION, 0, 0
					.endif
			
				;-----------------------------
				;  Free memory
				;-----------------------------
						
				invoke SquareFree, pUserData
				
			;-----------------------------
			.else
			;-----------------------------
				invoke DefWindowProc, hWnd, uMsg, wParam, lParam
				ret
			;-----------------------------
				.endif
			;-----------------------------
		xor eax,eax
		ret
InfoTextProc ENDP

;-----------------------------
;	CFHookProc: Updates text 
;-----------------------------
CFHookProc PROC hdlg:HWND, uiMsg:DWORD, wParam:WPARAM, lParam:LPARAM

			mov eax, uiMsg
			;-----------------------------
			 .if eax==0C06Ch		; uMsg
			;-----------------------------
				
					
					
				invoke InvalidateRect, cf.CHOOSEFONT.hwndOwner, 0, TRUE
				invoke RedrawWindow, cf.CHOOSEFONT.hwndOwner, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW or RDW_ALLCHILDREN

				;invoke InvalidateRect, cf.CHOOSEFONT.hwndOwner, 0, TRUE
				
			;-----------------------------
			.endif
			;-----------------------------
			
	xor eax,eax
	ret
CFHookProc ENDP




TextDialogFunc  PROC hwndDlg:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
LOCAL txtLength:DWORD, hIDC_TEXT:DWORD,
      pNewText:DWORD, pOldBuffer:DWORD
	
	mov eax, uMsg
	
	
	;-----------------------------
	 .if eax==WM_COMMAND		; uMsg
	;-----------------------------
		mov eax, wParam
		and eax, 0FFFFh
		;-----------------------------
		.if eax== IDCANCEL
		;-----------------------------
			invoke EndDialog,hwndDlg, wParam
			mov eax, TRUE
			ret
		;-----------------------------
		.elseif eax== IDOK
		;-----------------------------
				
				mov eax, pActiveWindowData
				
			;-----------------------------
			;  Store fgColor
			;-----------------------------
				mov ecx, fgColorResult
				mov [eax].Square.fgColor, ecx
				
			;-----------------------------
			;  Store bgColor
			;-----------------------------
				mov edx, bgColorResult
				mov [eax].Square.bgColor, edx
			
			
			;-----------------------------
			;  Get New Text Length
			;-----------------------------
				invoke GetDlgItem, hwndDlg, IDC_TEXT
				mov hIDC_TEXT, eax
				
				invoke SendMessage, eax, WM_GETTEXTLENGTH, 0,0
				add eax, 1
				mov txtLength, eax
				
			;-----------------------------
			;  Get old buffer
			;-----------------------------
				mov eax, pActiveWindowData
				mov eax,  [eax].Square.szText
				mov pOldBuffer,eax
				
			;-----------------------------
			;  Alloc new text buffer
			;-----------------------------
			
				invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, txtLength
				mov pNewText, eax
				
			;-----------------------------
			;  Copy Text
			;-----------------------------
				invoke SendMessage, hIDC_TEXT, WM_GETTEXT, txtLength, pNewText
				
			;-----------------------------
			;  Attach buffer
			;-----------------------------
			
				mov ecx, pActiveWindowData
				mov eax, pNewText
				mov [ecx].Square.szText, eax
			
			;-----------------------------
			;  Dealloc old text buffer
			;-----------------------------
				invoke HeapFree, hHeap,HEAP_ZERO_MEMORY, pOldBuffer
			
			
			invoke InvalidateRect, hActiveWindow, 0, TRUE
			
			invoke EndDialog,hwndDlg, wParam
			mov eax, TRUE
			ret
		;-----------------------------
		.elseif eax == IDC_FORECHOOSECOLOR
		;-----------------------------
			mov eax, fgColorResult
			mov cc.CHOOSECOLOR.rgbResult, eax
			invoke ChooseColor, Offset cc
			.if eax!=0
				mov eax, cc.CHOOSECOLOR.rgbResult
				mov fgColorResult, eax
				invoke GetDlgItem, hwndDlg, IDC_STATIC_FG
				invoke InvalidateRect, eax,0,TRUE
			.endif
		;-----------------------------
		.elseif eax == IDC_BACKCHOOSECOLOR
		;-----------------------------
			mov eax, bgColorResult
			and eax, 000FFFFFFh
			mov cc.CHOOSECOLOR.rgbResult, eax
			invoke ChooseColor, Offset cc
			.if eax!=0
				mov eax, cc.CHOOSECOLOR.rgbResult
				.if bgColorResult>000FFFFFFh
					or eax, 0FF000000h
				.else
					and eax, 000FFFFFFh
				.endif
				mov bgColorResult, eax
				invoke GetDlgItem, hwndDlg, IDC_STATIC_BG
				invoke InvalidateRect, eax,0,TRUE
			.endif
		;-----------------------------
		.elseif eax == IDC_RADIO_BACKCOLOR
		;-----------------------------
			and bgColorResult, 000FFFFFFh
		;-----------------------------
		.elseif eax == IDC_RADIO_BACKTRANSPARENT
		;-----------------------------
			or bgColorResult, 0FF000000h
		;-----------------------------
		.endif
		;-----------------------------
	;-----------------------------
	 .elseif eax==WM_CTLCOLORSTATIC		; uMsg
	;-----------------------------
		invoke GetDlgItem, hwndDlg, IDC_STATIC_FG
		.if lParam == eax
			.if hFgStatBrush != 0
				invoke DeleteObject, hFgStatBrush
				mov hFgStatBrush, 0
			.endif
			mov eax, fgColorResult
			mov myFgStatBrush.LOGBRUSH.lbColor, eax
			invoke CreateBrushIndirect, Offset myFgStatBrush
			mov hFgStatBrush, eax
			ret
		.endif
		invoke GetDlgItem, hwndDlg, IDC_STATIC_BG
		.if lParam == eax
			.if hFgStatBrush != 0
				invoke DeleteObject, hBgStatBrush
				mov hBgStatBrush, 0
			.endif
			mov eax, bgColorResult
			and eax, 000FFFFFFh
			mov myBgStatBrush.LOGBRUSH.lbColor, eax
			invoke CreateBrushIndirect, Offset myBgStatBrush
			mov hBgStatBrush, eax
			ret
		.endif
	;-----------------------------
	 .elseif eax==WM_INITDIALOG		; uMsg
	;-----------------------------
	
		;-----------------------------
		;  Init Text
		;-----------------------------
		mov eax, pActiveWindowData
		invoke SetDlgItemText, hwndDlg, IDC_TEXT, [eax].Square.szText
		
		;-----------------------------
		;  Init Chosen Colors
		;-----------------------------
			
			mov eax, pActiveWindowData
			
			mov ecx, [eax].Square.fgColor
			and ecx, 0FFFFFFh
			mov fgColorResult, ecx
			mov edx, [eax].Square.bgColor
			mov bgColorResult, edx
			
		;-----------------------------
		;  Init Radio Buttons
		;-----------------------------
		
			mov eax, bgColorResult
			.if eax>0FFFFFFh
				mov eax, IDC_RADIO_BACKTRANSPARENT
			.else
				mov eax, IDC_RADIO_BACKCOLOR
			.endif
			invoke CheckRadioButton, hwndDlg, IDC_RADIO_BACKTRANSPARENT, IDC_RADIO_BACKCOLOR, eax
			
		
	;-----------------------------
	.endif
	;-----------------------------
			
	xor eax,eax
	ret
TextDialogFunc ENDP


;-------------------------------------------
;  Allocates Memory for an uninitialized
;  Square, but leaves szText empty.
;-------------------------------------------

SquareAlloc		PROC
LOCAL pTempFont:DWORD
		invoke HeapAlloc, hHeap, HEAP_ZERO_MEMORY, Sizeof LOGFONT
		mov pTempFont, eax
		invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, Sizeof Square
		mov ecx, pTempFont
		mov [eax].Square.hLogFont,ecx
		
	ret
SquareAlloc ENDP


;-------------------------------------------
;  Deallocates Memory for a Square
;-------------------------------------------

SquareFree		PROC pSquare:DWORD
		.if pSquare == 0
			ret
		.endif

		mov eax, pSquare
		mov eax, [eax].Square.szText
		.if eax != 0
			invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, eax
		.endif
		 
		mov eax, pSquare
		mov eax, [eax].Square.hLogFont

		.if eax != 0
			invoke HeapFree, hHeap, HEAP_ZERO_MEMORY, eax
		.endif
		
		
		invoke HeapFree, hHeap,HEAP_ZERO_MEMORY, pSquare
		
	ret
SquareFree ENDP

;-------------------------------------------
;  Copies a source square into desination square
;-------------------------------------------
SquareCopy		PROC pSquareDest:DWORD, pSquareSrc:DWORD

		push esi
		push edi
		push ebx
			;-------------------------------------------
			;  Set up source and destination objects
			;-------------------------------------------
					mov esi, pSquareSrc
					mov edi, pSquareDest
					
					
			;-------------------------------------------
			;  Point to Locations for Font
			;-------------------------------------------
					mov ebx, [esi].Square.hLogFont
					mov edx, [edi].Square.hLogFont
				;-------------------------------------------
				;  Copy hLogFont
				;-------------------------------------------
					mov ecx, 14
					@@:
						mov eax, dword ptr [ebx+ecx*4]
						mov dword ptr [edx+ecx*4], eax
						sub ecx, 1
						jnc @B
					
			;-------------------------------------------
			;  Deallocate string of destination if it exists
			;-------------------------------------------
					.if [edi].Square.szText !=0
						invoke HeapFree, hHeap,HEAP_ZERO_MEMORY, [edi].Square.szText
					.endif
			;-------------------------------------------
			;  Point to Locations for Text
			;-------------------------------------------
				;-------------------------------------------
				;  Get Length of source string
				;-------------------------------------------
					invoke StringLength, [esi].Square.szText
					add eax, 1
				;-------------------------------------------
				;  Allocate and copy
				;-------------------------------------------
					invoke HeapAlloc, hHeap, HEAP_ZERO_MEMORY, eax
					mov [edi].Square.szText, eax
					
					invoke StringCopy,  [edi].Square.szText,[esi].Square.szText
					
			;-------------------------------------------
			;  Point to Locations for Square
			;-------------------------------------------
						
				;-------------------------------------------
				;  Copy Square
				;-------------------------------------------
					mov eax, dword ptr [esi].Square.bgColor
					mov ecx, dword ptr [esi].Square.fgColor
					mov dword ptr [edi].Square.bgColor, eax
					mov dword ptr [edi].Square.fgColor, ecx
					
					
		pop ebx	
		pop edi
		pop esi
	ret
SquareCopy ENDP







EnumAllChildren PROC hWnd:HWND, lParam:LPARAM
LOCAL pUserData:DWORD,
	  LengthOfString:DWORD,
	  LengthOfEntry:DWORD,
	  myRect:RECT, mainRect:RECT

	invoke GetWindowLong, hWnd, GWL_USERDATA
	mov pUserData, eax
	;-------------------------------------------
	.if lParam==0  ; Add size to CountTotalFileSize 
	;-------------------------------------------
	
	    ; eax = pUserData
	    
		;----------------------
		;  Add size of Square
		;----------------------
			add CountTotalFileSize, Sizeof Square + 16  ; ( 4 DWORDS for coordinates)
		;----------------------
		;  Add size of LOGFONT
		;----------------------
			.if [eax].Square.hLogFont != 0
				add CountTotalFileSize, Sizeof LOGFONT
			.endif
		;----------------------
		;  Add size of szText
		;----------------------
			invoke StringLength, [eax].Square.szText 
			add eax, 4  ; Align Up To 4
   			and eax, -4       
			add CountTotalFileSize, eax
			
			add CountTotalNumberOfWindows, 1
			
	;-------------------------------------------
	.elseif lParam==1  ; Write to OffsetViewOfFile
	;-------------------------------------------
	push esi
	push edi
	push ebx
		; /--------------------------\
		; |    File Entry Format     |
		; |--------------------------|
		; |                          |
		; |  LengthOfEntry:DWORD     |
		; |  LengthOfString:DWORD    |
		; |  fgColor:DWORD           |
		; |  bgColor:DWORD           |
		; |  CoordX:DWORD            |
		; |  CoordY:DWORD            |
		; |  CoordW:DWORD            |
		; |  CoordH:DWORD            |
		; |  LOGFONT:BYTE[60]        |
		; |  String:BYTE(?)          |
		; |                          |
		; \--------------------------/
		
			mov esi, pUserData
			mov edi, OffsetViewOfFile
		
		
		;----------------------
		;  Get LengthOfString
		;----------------------
			invoke StringLength, [esi].Square.szText 
			add eax, 1
			mov LengthOfString, eax
		;----------------------
		;  Get LengthOfEntry
		;----------------------
			add eax, 60+32+3 ; Align Up To 4
   			and eax, -4       
			mov LengthOfEntry, eax
			
		;----------------------
		;  UPDATE NEXT OffsetViewOfFile
		;----------------------
			add OffsetViewOfFile, eax
			
		;----------------------
		;  Write To File
		;----------------------
		
			mov eax, LengthOfEntry
			mov ecx, LengthOfString
			mov dword ptr [edi],    eax ; LengthOfEntry:DWORD
			mov dword ptr [edi+4],  ecx ; LengthOfString:DWORD
			
			mov eax, [esi].Square.fgColor
			mov ecx, [esi].Square.bgColor
			mov dword ptr [edi+8],  eax  ; fgColor:DWORD
			mov dword ptr [edi+12], ecx  ; bgColor:DWORD
			
			
			
				;-----------------------------
				;  CoordX:DWORD            
				;  CoordY:DWORD            
				;  CoordW:DWORD            
				;  CoordH:DWORD            
				;-----------------------------
				
					invoke GetWindowRect, hWnd, ADDR myRect
					mov eax, myRect.RECT.right
					mov ecx, myRect.RECT.bottom
					sub eax, myRect.RECT.left
					sub ecx, myRect.RECT.top
					mov dword ptr [edi+24], eax  ; CoordW:DWORD
					mov dword ptr [edi+28], ecx  ; CoordH:DWORD
					invoke ScreenToClient, hMainWindow, ADDR myRect
					mov eax, myRect.RECT.left
					mov ecx, myRect.RECT.top
					mov dword ptr [edi+16], eax  ; CoordX:DWORD
					mov dword ptr [edi+20], ecx  ; CoordY:DWORD
				
				;-----------------------------
				;  LOGFONT:BYTE[60]
				;-----------------------------
					add edi, 32
					push esi
					push ebx
						mov esi, [esi].Square.hLogFont
						for N,<0, 16, 32>
						mov eax, dword ptr [esi + N + 0 ]
						mov ebx, dword ptr [esi + N + 4 ]
						mov ecx, dword ptr [esi + N + 8 ]
						mov edx, dword ptr [esi + N + 12]
						mov dword ptr [edi + N + 0 ], eax
						mov dword ptr [edi + N + 4 ], ebx
						mov dword ptr [edi + N + 8 ], ecx
						mov dword ptr [edi + N + 12], edx
						endm
						mov eax, dword ptr [esi + 48 + 0 ]
						mov ecx, dword ptr [esi + 48 + 4 ]
						mov edx, dword ptr [esi + 48 + 8 ]
						mov dword ptr [edi + 48 + 0 ], eax
						mov dword ptr [edi + 48 + 4 ], ecx
						mov dword ptr [edi + 48 + 8 ], edx
					pop ebx
					pop esi
				
			add edi, 60
			invoke StringCopy, edi, [esi].Square.szText
	pop ebx	
	pop edi
	pop esi
	;-------------------------------------------
	.elseif lParam==2  ; Destroy
	;-------------------------------------------
	
		invoke DestroyWindow, hWnd
	;----------------------
	.endif
	;----------------------
	
	
	; Continue Enumeration
	mov eax, 1
	ret
EnumAllChildren ENDP

End Start